//+------------------------------------------------------------------+
//|                                                          RNN.mq5 |
//|                                 Copyright 2012, Yury V. Reshetov |
//|                              http://www.mql5.com/ru/articles/366 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Yury V. Reshetov"
#property link      "http://www.mql5.com/ru/articles/366"
#property version   "1.00"
//---   
input int      x0 = 50; //    0  
input int      x1 = 50; //    1  
input int      x2 = 50; //    2  
input int      x3 = 50; //    3  
input int      x4 = 50; //    4  
input int      x5 = 50; //    5  
input int      x6 = 50; //    6  
input int      x7 = 50; //    7  
input double   sl = 500.0; //       
input double   lots = 1.0; //     
static datetime last_time=0; //   last_time      

MqlTradeRequest request;
MqlTradeResult  result;
MqlDateTime     dt;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   last_time=0;
   request.symbol = Symbol();
   request.volume = lots;
   request.deviation=20;
   request.action=TRADE_ACTION_DEAL;
   request.type_filling=ORDER_FILLING_AON;
   request.sl = 0.0;
   request.tp = 0.0;
   request.magic=888;
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---     
   if(!isNewBar())
     {
      //    ,  
      return;
     }

//---   
   int total=PositionsTotal();

//---   
   for(int i=0; i<total; i++)
     {
      //---  
      OrderSelect(i);
      //---     "" 
      if(Symbol()==PositionGetSymbol(i))
        {
         //---    ,  
         return;
        }
     }

//---  ()  
   double ts=tradesSingal();

   if(ts<0.0)
     { //---      
      request.price=NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_ASK),_Digits);
      request.sl = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_BID) - sl * _Point, _Digits);
      request.tp = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_BID) + sl * _Point, _Digits);
      request.type=ORDER_TYPE_BUY;
      OrderSend(request,result);
     }
   else
     {
      //---      
      request.price=NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_BID),_Digits);
      request.sl = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_ASK) + sl * _Point, _Digits);
      request.tp = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_ASK) - sl * _Point, _Digits);
      request.type=ORDER_TYPE_SELL;
      OrderSend(request,result);
     }
//---  
   return;
  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---
  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
//|  true,       /  |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//---  
   datetime lastbar_time=datetime(SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE));
//---     
   if(last_time==0)
     {
      //---     
      last_time=lastbar_time;
      return(false);
     }
//---   
   if(last_time!=lastbar_time)
     {
      //---     true
      last_time=lastbar_time;
      return(true);
     }
//---     -    ,  false
   return(false);
  }

//+------------------------------------------------------------------+
//|                     |
//+------------------------------------------------------------------+
double tradesSingal()
  {
//---      
   int handle=iRSI(_Symbol,0,9,PRICE_OPEN);
   double rsi[30];
   CopyBuffer(handle,0,0,28,rsi);

//---   RSI    0  1 
   double a1 = rsi[0] / 100.0;
   double a2 = rsi[9] / 100.0;
   double a3 = rsi[18] / 100.0;

//---       
   double results=RNN(a1,a2,a3);

   string s=Symbol()+", Probability for Short (Sell) position: "+DoubleToString(results,4);

   if(results>0.5)
     {
      //--     
      Print(s);
     }
   else
     {
      double r=1.0-results;
      s=Symbol()+", Probability for Long (Buy) position: "+DoubleToString(r,4);
      //---     
      Print(s);
     }

//---     e-mail
   SendMail(s,s);

// ,        -1  1 
   results=results*2.0-1.0;

   return(results);
  }
//+------------------------------------------------------------------+
//|   . .                                 |
//|                           |
//| p1, p2, pn -             |
//+------------------------------------------------------------------+
double RNN(double p1,double p2,double p3)
  {
//---        
   double y0 = x0; //   0  
   double y1 = x1; //   1  
   double y2 = x2; //   2  
   double y3 = x3; //   3  
   double y4 = x4; //   4  
   double y5 = x5; //   5  
   double y6 = x6; //   6  
   double y7 = x7; //   7  

//---  ,     
   double probability=
                      (1.0 - p1) * (1.0 - p2) * (1.0 - p3) * y0 + //  0
                      (1.0 - p1) * (1.0 - p2) * p3 * y1 +         //  1
                      (1.0 - p1) * p2 * (1.0 - p3) * y2 +         //  2
                      (1.0 - p1) * p2 * p3 * y3 +                 //  3
                      p1 * (1.0 - p2) * (1.0 - p3) * y4 +         //  4
                      p1 * (1.0 - p2) * p3 * y5 +                 //  5
                      p1 * p2 * (1.0 - p3) * y6 +                 //  6
                      p1 * p2 * p3 * y7;                          //  7

//---     
   probability=probability/100.0;

//---     
   return(probability);
  }
//+------------------------------------------------------------------+
